
cv.rrrr <- function(X,Y,nrank,lambdas,nfold,seed=1){
	set.seed(seed)
    p <- ncol(X)
    q <- ncol(Y) 
# Index for training vs test set
	fold <- rep(NA,nrow(Y))
	fold <- sample(rep(1:nfold,nrow(Y)/nfold))
	cv.error <- NULL
	
for(j in 1:nfold){
		print(paste("cross validation for dataset ",j,sep=""))
		error <- NULL
		tmp <- 1
		ytrain <- Y[which(fold!=j),]
		ytest <- Y[which(fold==j),]		
		Xtrain <- X[which(fold!=j),]		
		Xtest <- X[which(fold==j),]			
		ntrain <- nrow(Xtrain)

	for(lambda in lambdas){
		model <- rrrr(ytrain,Xtrain,nrank,lambda,thres=1e-6,init.B0=init.B0,init.C0=init.C0)
		estA <- model$B0
		predictedY <- Xtest%*%estA
		error <- c(error,sum((predictedY-ytest)^2))	
}
		cv.error <- rbind(cv.error,error)
	}
	
	return(list(cv.error=cv.error,lambdas=lambdas))
}

	


rrrr <- function(Y,X,nrank,lambda,thres,init.B0=init.B0,init.C0=init.C0){
	
	n <- nrow(Y)
	q <- ncol(Y)
	p <- ncol(X) 
    H0 <- ginv(crossprod(X)) %*% t(X)
    H <- X%*%H0
    B0 <- init.B0 <-matrix(0,p,q)
    C0 <- init.C0 <- matrix(0,n,q)
    if(is.null(init.B0)!=TRUE){
    	B0 <- init.B0
    }
    if(is.null(init.C0)!=TRUE){
    	C0 <- init.C0
    }
	error <- 100
while(error > thres){
	R <- Y - X %*% B0
    
    C0 <- Soft(R, lambda)
    
    Y0 <- Y-C0
    
    XC <- H%*%Y0
    
    V <- svd(XC)$v[,1:nrank]
    
    B0 <- H0%*%Y0%*%tcrossprod(V)
    
    error <- sum((B0-init.B0)^2)
    init.B0 <- B0
    
    }
   
	return(list(B0=B0,C0=C0))
	
}